<?php
// Array is never equal to an object, unless that object has a 
// cast_object handler supporting to ARRAY casts (I couldn't find
// such a handler, even in SplFixedArray).

// Array vs same array as object?
echo "--- ARRAY vs anonymous object based on that ARRAY\n";
$arr = array("a" => "b");
$obj = (object)$arr;
var_dump($arr == $obj); // not equal

// Sadly (as of PHP 5.4.10) SplFixedArray has no cast_object defined
// for ARRAY, which it totally should have, since it even has a 
// toArray() method.
echo "--- SplFixedArray (no to ARRAY cast_object)\n";
$splarr = new \SplFixedArray(2);
$splarr[0] = 2;
$splarr[1] = "foo";
var_dump($splarr);
var_dump($splarr == array(2, "foo")); // not equal ($splarr has no casts)
//var_dump((array)$splarr); // it can be cast
// var_dump((array)$splarr == array(2, "foo")); this would be equal



