<?php
// Standard PHP objects cast_object always returns bool(TRUE) when
// the object is cast to BOOL.
echo "--- standard PHP objects\n";
class Test {}; // A standard class.
$oTest = new Test;
$oStd = (object)array("a"=>"b");
var_dump(true == $oTest); // equal
var_dump(true == $oStd);  // equal

// SimpleXML object's cast_object actually does does a smart BOOL
// conversion
echo "--- SimpleXMLElement (sxe) objects\n";
$sxe_empty = new \SimpleXMLElement("<a></a>");
$sxe_good  = new \SimpleXMLElement("<a><b>xyz</b></a>");

var_dump(true == $sxe_empty); // not equal
var_dump(true == $sxe_good);  // this should be equal, and honestly I have no
                              // idea why this is not equal, especially that
                              // (bool)$sxe_good is true
var_dump(false == $sxe_empty); // equal
var_dump(false == $sxe_good);  // equal (?why? see above note)

// FilesystemIterator's cast_object returns FAILURE for BOOL conversion
echo "--- FilesystemIterator's FAILURE to cast objects\n";
$i = new \FilesystemIterator(dirname(__FILE__));
var_dump(true  == $i); // not equal
var_dump(false == $i); // not equal (sic!)

// These tests do not cover objects with no cast_object handler. However
// in such case it would be:
// var_dump(true == $obj);  // equal
// var_dump(false == $obj); // not equal

