<?php
// Identical to LONG vs OBJECT.

// Standard PHP objects cast_object always returns DOUBLE(1.0) and raises 
// an E_NOTICE (I wonder why it doesn't just return FAILURE).
echo "--- standard PHP objects\n";
class Test {}; // A standard class.
$oTest = new Test;
$oStd = (object)array("a"=>"b");
var_dump(1.0 == $oTest); // equal
var_dump(1.0 == $oStd);  // equal

// FilesystemIterator's cast_object returns FAILURE for DOUBLE conversion
echo "--- FilesystemIterator's FAILURE to cast objects\n";
$i = new \FilesystemIterator(dirname(__FILE__));
var_dump(1.0 == $i); // not equal
var_dump(0.0 == $i); // not equal

// These tests do not cover objects with no cast_object handler. However
// in such case it would be:
// var_dump(1.0 == $obj);  // equal (and not equal for any other)

