<?php
// Standard PHP objects cast_object always returns LONG(1) and raises 
// an E_NOTICE (I wonder why it doesn't just return FAILURE).
echo "--- standard PHP objects\n";
class Test {}; // A standard class.
$oTest = new Test;
$oStd = (object)array("a"=>"b");
var_dump(1 == $oTest); // equal
var_dump(1 == $oStd);  // equal

// FilesystemIterator's cast_object returns FAILURE for BOOL conversion
echo "--- FilesystemIterator's FAILURE to cast objects\n";
$i = new \FilesystemIterator(dirname(__FILE__));
var_dump(1 == $i); // not equal
var_dump(0 == $i); // not equal

// These tests do not cover objects with no cast_object handler. However
// in such case it would be:
// var_dump(1 == $obj);  // equal

