<?php
echo "--- standard object comparator (zend_std_compare_objects)\n";
class Test {
  public $x = 5;
}

$anonobj1 = (object)array("x" => 5);
$anonobj2 = (object)array("x" => " 5 <-- five");
$testobj1 = new Test;
$testobj2 = new Test;

var_dump($testobj1 == $anonobj1); // not equal (different class)
var_dump($anonobj1 == $anonobj2); // equal, all anonymous objects are of the same class

echo "--- deep recursion comparison\n";
echo "skipping, since it would ".
  "<a href=\"https://bugs.php.net/bug.php?id=63882\">crash the PHP ". 
  "interpreter</a>\n";
// $testobj1->x = $testobj2;
// $testobj2->x = $testobj1;
// var_dump($testobj1 == $testobj2);
// Skipping, this would crash the interpreter (see bug #63882)

// Zend closures are object and they have a compare handler that says they
// are equal only if it's actually the same object.
echo "--- closure comparison\n";
$closure1 = function(){};
$closure2 = function(){};
var_dump($closure1 == $closure2); // not equal, different objects

$ptr = &$closure1;
var_dump($ptr == $closure1); // equal, same object

// Two objects of different class
echo "--- different object comparison\n";
date_default_timezone_set("Europe/Zurich");
class A {}

$a = new A;
$b = new \DateTime;

var_dump($a == $b); // equal in PHP 5.4.6 + raises 2x E_NOTICE
                    // not equal in PHP 5.4.10

// Note: I totally ignored proxy objects (since I don't undersand them at
// the moment of creating these tests; not sure where are they used etc;
// actually the code for them exists, but hard to find a reference; TODO)

