<?php
$f = fopen('php://output', 'w');
var_dump($f);

// Standard PHP objects cast_object will always fail (so it's always not equal).
$obj = (object)array("a"=>"b");
var_dump($obj == $f); // not equal

fclose($f); // Changes nothing.
var_dump($obj == $f); // not equal

// Note: I don't know of any built-in / standard extension class that has the
// cast_object handler supporting to RESOURCE conversion.

// PDORow using sqlite (has no cast_object, so it will be cast to LONG(1),
// and will be compared with the resource cast to LONG).
echo "--- PDORow object (has no cast_object handler)\n";
try {
  // Create a PDORow object using sqlite.
  $r = new \PDO("sqlite::memory:");
  $r = $r->query("SELECT sqlite_version()");
  $r = $r->fetch(\PDO::FETCH_LAZY);

  var_dump($r == $f); // This would be equal if this would be resource #1.
                      // Note: this will raise an E_NOTICE.

} catch (Exception $e) {
  echo "skipping PDORow test ({$e->message})\n";
}

